export default class AsyncQueue {
    dataQueue = [];
    resolveQueue = [];
    async *[Symbol.asyncIterator]() {
        while (true) {
            while (this.dataQueue.length === 0) {
                await new Promise((resolve) => this.resolveQueue.push(resolve));
            }
            const data = this.dataQueue.shift();
            if (data.done)
                break;
            yield data.value;
        }
    }
    push(value) {
        this.dataQueue.push({ value, done: false });
        this.resolveQueue.shift()?.();
    }
    done() {
        this.dataQueue.push({ value: null, done: true });
        this.resolveQueue.shift()?.();
    }
    get size() {
        return this.dataQueue.length;
    }
}
//# sourceMappingURL=AsyncQueue.js.map